%% Demo 2b - Phase contrast microscopy images / Full view segmentation
%
params = struct('useFillHoles', 1, 'minSegmAreaPx', 500, 'useFgrPropagation', 1, 'useNonMergingConstr', 1,...
                'debugMode', 1);
              
% using symmetric boundary costs        
params.lambda = 0.15;
params.binaryTermType = 'symmetric';
params.sigma = 0.008;
predLabels_symm = runTracking('demo/t015.tif','demo/model_PhC-C2DH-U373.mat', params);

% using asymmetric boundary costs   
params.lambda = 0.2;
params.binaryTermType = 'asymmetric-darkToBright';
params.sigma = 0.006;
predLabels_asymm = runTracking('demo/t015.tif','demo/model_PhC-C2DH-U373.mat', params);

% comparison
im = im2double(imread('demo/t015.tif'));
figure('units','normalized','outerposition',[0 0 1 1]);
subplot(2,2,[1,2]); imshow(im,[]); title('Raw image');
subplot(2,2,3); imshow(cat(3, im, im+0.2*double(predLabels_symm(:,:,1)'>0), im+0.2*double(predLabels_symm(:,:,1)'>0)));
title('Graph cut segmentation'); xlabel('Symmetric boundary costs');
subplot(2,2,4); imshow(cat(3, im+0.2*double(predLabels_asymm(:,:,1)'>0), im, im));
title('Graph cut segmentation'); xlabel('Asymmetric boundary costs / dark-to-bright preference');