%% Demo 2c - Phase contrast microscopy images / Sequence segmentation and tracking 
% 
params = struct('useFillHoles', 1, 'minSegmAreaPx', 500, 'useFgrPropagation', 1, 'useNonMergingConstr', 1,...
                'debugMode', 0);

% using asymmetric boundary costs           
params.lambda = 0.125;
params.binaryTermType = 'asymmetric-darkToBright';
params.sigma = 0.004;
[predLabels, fileLst] = runTracking('demo/t*.tif','demo/model_PhC-C2DH-U373.mat', params);

% result plot
figure('units','normalized','outerposition',[0 0 1 1]);
maxLabel = max(1,double(max(predLabels(:))));
nFrames = size(predLabels,3);
for i = 1:nFrames
  im = im2double(imread(['demo/' fileLst{i}]));
  subplot(2,nFrames,i); imshow(cat(3, im+0.2*double(predLabels(:,:,i)'>0), im, im));
  title('Cell segmentation (mask in red)');
  xlabel(fileLst{i});
  subplot(2,nFrames,nFrames+i); imagesc(predLabels(:,:,i)',[0 maxLabel]); axis image; axis off; colormap(jet(maxLabel+1)); %colorbar;
  title('Cell tracking (labels in color)');
end